with Ada.Text_IO, Strings, Ints, Flts, Globals, Reps, Params;
use Ada.Text_IO, Strings, Ints, Flts, Globals, Reps, Params;
with Params.Names,TSpherics,TSpherics.Fix;

pragma Elaborate_All (Ada.Text_IO,Strings,Ints,Flts,Globals,Reps);
pragma Elaborate_All (TSpherics,TSpherics.Fix);

procedure Approx_FixPt(P: in Param) is

   package PN is new Params.Names(P => P, Trunc => True);
   use PN;

   subtype Scalar is Rep;

   package TSphs is new TSpherics(Pram => P, Scalar => Scalar, Trunc => True);
   package Fix is new TSphs.Fix;

   use TSphs,Fix,TSphs.SCoeffs;

   Epsilon: constant Radius := 1.0e-15;
   F: Spheric;
   M: QC_Matrix;
   
begin

   Verbosity := 2;
   Show("",P);
   Read(Input_Dir & Fix_Name,F);
   ForceParity(Par,Mixed,F);
   ProjAll(F);
   ApproxFix(F,M,Epsilon);
   Show1("Norm F",MaxNorm(F));
   Write(Output_Dir & Fix_Name,F);
   --  Plot(Pic_Dir & Plot_Name,F,Zero);
   --  Plot(Pic_Dir & Plot_Name,F,128,64,128);
   SM.Write(Input_Dir & Mat_Name,M);

end Approx_FixPt;
